/**
*LVM App
* There are different ways implementing an App
*/
var lvmApp = lvmApp || {};  //Define App namespace, if you want.
/**
*Constructor UNAS App
*/
lvmApp.App = function () {
    this.id = 'lvmApp';
    this.name = 'Volumes Manager';
    this.version = '6.0.44';
    this.active = false;
    this.menuIcon = '/apps/lvm/images/logo.png?v=6.0.44&';
    this.shortcutIcon = '/apps/lvm/images/logo.png?v=6.0.44&';
    this.entryUrl = '/apps/lvm/volumes_manager.html?v=6.0.44&';
    //this.entryHelpUrl = '/apps/lvm/volumes_manager_help.html?v=6.0.44&';
    var self = this;
    this.lvmAppWindow = function () { //create app window
        if(UNAS.CheckAppState('Volumes Manager')){
            return false;
        }
        self.window=new MUI.Window({
            id: 'lvmAppWindow',
            title: UNAS._('Volumes Manager'),
            icon: '/apps/lvm/images/logo_small.png?v=6.0.44&',
            width: 800,
            height: 480,
            maximizable: false,
            resizable: true,
            scrollbars: false,
            resizeLimit: { 'x': [500, 2000], 'y': [200, 3000] },
            loadMethod: 'xhr',
            contentURL: '/apps/lvm/volumes_manager.html?v=6.0.44&',
            require: {  css: ['/apps/lvm/css/lvm.css'] },
            onBeforeBuild: function(){UNAS.SetAppOpenedWindow("Volumes Manager",'lvmAppWindow')}
        });
    };
    this.lvmAppUninstall = function (){
        UNAS.RemoveDesktopShortcut('Volumes Manager');
        UNAS.RemoveMenu('Volumes Manager');
        UNAS.RemoveAppFromGroups('Volumes Manager', 'ControlPanel');
        UNAS.RemoveAppFromGroups('Volumes Manager', 'Help');
        UNAS.RemoveAppFromApps('Volumes Manager');
    }
    new UNAS.Menu('UNAS_ControlPanel_Storage_Menu', this.name, this.menuIcon, 'Volumes Manager', '', this.lvmAppWindow);
    //new UNAS.DesktopShortcut(this.name, this.shortcutIcon, 'Volumes Manager', this.lvmAppWindow);
    new UNAS.RegisterToAppGroup(this.name, 'ControlPanel', {'Type' : 'Storage', 'Location' : 2, "Icon": this.shortcutIcon, "Url": this.entryUrl},{});
    //new UNAS.RegisterToAppGroup(this.name, 'Help', {'Type' : 'Storage', 'Location' : 2, "Icon": this.shortcutIcon, "Url": this.entryHelpUrl},{});

    var OnChangeLanguage = function (e) {
        UNAS.SetMenuTitle('Volumes Manager', UNAS._('Volumes Manager')); //translate menu
        //UNAS.SetShortcutTitle('Volumes Manager', UNAS._('Volumes Manager')); //translate shortcut
        if (typeof self.window !== 'undefined') {
            UNAS.SetWindowTitle('lvmAppWindow', UNAS._('Volumes Manager'));
        }
    }
    UNAS.LoadTranslation('/apps/lvm/languages/Translation?v='+this.version, OnChangeLanguage);
    UNAS.Event.addEvent('ChangeLanguage', OnChangeLanguage);
    UNAS.CreateApp(this.name,this.shortcutIcon,this.lvmAppWindow,this.lvmAppUninstall);
};
new lvmApp.App(); //Create app
