function getThinpoolList(vgname) {
  return new Promise(function(resolve, reject) {
    jQuery.ajax({
      url: "/wmi/index.php",
      type: "POST",
      async: true,
      data: JSON.stringify({
        "token": UToken,
        "cmd": 'lv_thinpool_loadby',
        "params": {
          vg: vgname
        }
      }),
      dataType: 'json',
      success: function(res) {
        resolve(res);

        jQuery('#jv-freesize').val(vgfree_size_g);
        if (res.err == 0) {
          var info = res.results || {};
          jQuery('#jv-thinpoolhost').empty();
          var freesize = vgfree_size_g;
          var i = 0;
          for (var v in info) {
            if (info.hasOwnProperty(v)) {
              var thdata = info[v];
              var thdom = templateAppend_lvm('#jv-thinpoolhost', 'jvt-thin-tr', 'jvt-thin-tr' + i);
              thdata['thinpoolname'] = v;
              thdom.data('thinfo', thdata);
              thdom.find('.bfbval').attr('max', thdata.capacity + freesize).attr('min', thdata.capacity);
              // thdom.find('.bfbval').attr('max', thdata.capacity + freesize);
              // thdom.find('.bfbval').attr('min', thdata.capacity);
              thdom.find('.dmpath').text(thdata.dmpath);

              thdom.find('.jvc-size').text(formSize(thdata.capacity * 1024));
              thdom.find('.jvc-thinpoolReservation').val(thdata.capacity).jRange({
                from: thdata.capacity,
                to: thdata.capacity + freesize,
                step: 1,
                width: 160,
                showLabels: true,
                showScale: true
              });

              thdom.find('.bfbval').bind('input propertychange', function(e) {
                if (+jQuery(this).val() < +jQuery(this).attr('min')) {
                  jQuery(this).val(jQuery(this).attr('min'))
                }
              });

              thdom.find('.confirmedit').on('click', function() {
                var p_node = jQuery(this).closest('tr.jvc-thin-tr');
                var p_data = p_node.data('thinfo');
                jQuery(this).addClass('disabledbtn');
                var n_size = +p_node.find('.jvc-thinpoolsize').val();
                var o_size = +p_node.find('.jvc-thinpoolsize').attr('min');
                var size = n_size - o_size;
                confirmModify(p_data.lv, size).then(function(){
                  p_node.find('.confirmedit').removeClass('disabledbtn');
                })
              })

              var mountpoint = 0;
              var lvs = thdata.lvs || {};
              for (var k in lvs) {
                if (lvs.hasOwnProperty(k)) {
                  if (lvs[k].mountpoint) {
                    mountpoint = 1;
                    break;
                  }
                }
              }

              if (mountpoint) {
                thdom.find('.deleteitem').addClass('disabledbtn');
              } else {
                thdom.find('.deleteitem').on('click', function() {
                  var p_node = jQuery(this).closest('tr.jvc-thin-tr');
                  var p_data = p_node.data('thinfo');
                  var h = '<div>' + UNAS._('Are you sure you want to delete the selected thin pool?') + '</div>' +
                    '<div style="margin-top: 10px;">' + UNAS._('##$@lvm@$##ThinPool##$@lvm@$##') + ' - ' + p_data.lv + '</div>'
                  th_alertWindowFn({
                    tips: h,
                  }, function() {
                    removeThinpool(p_data.lv);
                  })
                })
              }
            }
            i++;
          }
        }

      },
      error: function(XMLHttpRequest, textStatus, errorThrown) {
        alert(textStatus);
        reject(XMLHttpRequest);
      }
    });
  })

}

function confirmModify(lv, size) {
  return new Promise(function(resolve, reject) {
    jQuery.ajax({
      url: "/wmi/index.php",
      type: "POST",
      async: true,
      data: JSON.stringify({
        "token": UToken,
        "cmd": 'lv_thinpool_extend',
        "params": {
          vg: jQuery('#edit_vgname').text(),
          pool: lv,
          size: +size || 0
        }
      }),
      dataType: 'json',
      success: function(res) {
        if (res.err == 0) {
          getVGsInfo("");
          getThinpoolList(jQuery('#edit_vgname').text());
          GetVgInfo(jQuery('#edit_vgname').text());
        } else {
          alert(UNAS._('##$@lvm@$##Operation##$@lvm@$##') + UNAS._('##$@lvmlvcreate@$##Failed.##$@lvmlvcreate@$##'));
        }
        resolve(res);
      },
      complete: function(res) {
        resolve(res);
      },
      error: function(XMLHttpRequest, textStatus, errorThrown) {
        alert(textStatus);
        reject();
      }
    });
  })

}

function removeThinpool(lv) {
  jQuery.ajax({
    url: "/wmi/index.php",
    type: "POST",
    async: true,
    data: JSON.stringify({
      "token": UToken,
      "cmd": 'lv_thinpool_remove',
      "params": {
        vg: jQuery('#edit_vgname').text(),
        pool: lv
      }
    }),
    dataType: 'json',
    success: function(res) {
      // console.log(res);
      if (res.err == 0) {
        getVGsInfo("");
        getThinpoolList(jQuery('#edit_vgname').text());
      }

    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      alert(textStatus);
    }
  });
}

function modifySize(t) {
  var p_node = jQuery(t).closest('tr.jvc-thin-tr');
  p_node.find('.jvc-adjustop').hide();
  p_node.find('.jvc-conop').hide();
  p_node.find('.jvc-editop').show();
  p_node.find('.jvc-thinpoolsizeinput').show();
}

function cancelEdit(t) {
  var p_node = jQuery(t).closest('tr.jvc-thin-tr');
  p_node.find('.jvc-adjustop').show();
  p_node.find('.jvc-conop').show();
  p_node.find('.jvc-editop').hide();
  p_node.find('.jvc-thinpoolsizeinput').hide();
}

var thinpool_target = {};

function viewthinpoollist(t) {
  var p_node = jQuery(t).closest('tr.jvc-thin-tr');
  thinpool_target = p_node.data('thinfo');

  var execFailureWindow = new MUI.Modal({
    id: 'jv-viewthinpoolWindow',
    title: UNAS._('ThinVolume List'),
    contentURL: "/apps/lvm/thinpool.html?v=6.0.44",
    modal: true,
    width: 660,
    height: 290,
  });

}

(function() {

  var vgname = jQuery('#edit_vgname').text();
  getThinpoolList(vgname);
})()
